var $ = jQuery;
var langNotChosen = '– Не выбрана –';

$(function () {

    let settings = getSettings();

    function controlVisualization() {
        var disciplineType = $("input[name=DisciplineType]:checked").val();
        if (disciplineType === 'exam') {
            $("#SelectDisciplineDiv").show();
            $("#DownloadStatement").hide();
        } else if (disciplineType === 'credit') {
            $("#SelectDisciplineDiv").hide();
            $("#DownloadStatement").show();
        }
    }

    // on page loaded
    controlVisualization();

    var jDownloadStatement = $("#DownloadStatement");
    var jDownloadExamDocument = $("#DownloadExamDocument");
    var jSelectGroup = $("#SelectGroup");
    var jSelectDiscipline = $("#SelectDiscipline");
    var jDownloadXML = $("#DownloadXML");
    let $grade = $("#SelectGrade");


    $("#ExamChoice").change(controlVisualization);

    $("#CreditChoice").change(controlVisualization);

    let groupSelect = getGroupLoader(jSelectGroup,
        () => ({FacultyID: settings.facultyID, 'GradeID': +$grade.val()})
    ).setOnChange(OptionLoader.stubFoo);

    //Получить список групп по ID курса
    $grade.change(function () {
        let gradeID = +$grade.val();
        if (gradeID > 0)
            groupSelect.reload();
        else
            jDownloadStatement.turnOff();
        jDownloadExamDocument.turnOff();
        jDownloadXML.turnOff();
    });

    jSelectGroup.change(function () {
        var groupID = +jSelectGroup.val();
        if (groupID > 0) {
            jDownloadStatement.removeAttr("disabled");

            // Заполнить список дисциплин
            $.post(
                g_URLdir + "handler/GetData/GetDisciplinesForGroup",
                {
                    groupID,
                    semesterID: getRecordBook()
                },
                function (d) {
                    d = $.parseJSON(d);
                    if (d.success === true) {
                        var i = 0;
                        jSelectDiscipline.html("<option>" + langNotChosen + "</option>");
                        for (i in d.data) {
                            discipline = d.data[i];
                            if (discipline.Type !== 'exam')
                                continue;
                            jSelectDiscipline.append("<option value='" + discipline.ID + "'>" + discipline.SubjectName + "</option>");
                        }
                        if (i > 0)
                            jSelectDiscipline.removeAttr("disabled");
                    }
                }
            );
        }
        else jDownloadStatement.attr("disabled", "disabled");

        jDownloadXML.attr("disabled", "disabled");
        jDownloadExamDocument.attr("disabled", "disabled");
    });

    jSelectDiscipline.change(function () {
        var disciplineID = parseInt($(this).val()) || 0;
        if (disciplineID > 0) {
            jDownloadExamDocument.removeAttr("disabled");
            jDownloadXML.removeAttr("disabled");
        }
        else {
            jDownloadExamDocument.attr("disabled", "disabled");
            jDownloadXML.attr("disabled", "disabled");
        }
    });

    // Скачать ведомость
    $('body').on('click', '#DownloadStatement', function () {
        $.fileDownload(g_URLdir + 'handler/FileCreator/GenerateFinalFormsForGroup', {
            httpMethod: "POST",
            data: {
                "GroupID": parseInt($("#SelectGroup").val())//,
                //"ExamType": $("input[name=DisciplineType]:checked").val()
            },
            successCallback: function () {

            },
            failCallback: function () {
                EventInspector.error('У выбранной группы отсутствуют дисциплины с зачетом');
            }
        });
    });

    // Печать ведомости
    $('body').on('click', '#DownloadExamDocument', function () {
        $.fileDownload(g_URLdir + 'handler/FileCreator/GenerateFinalForm', {
            httpMethod: "POST",
            data: {
                "disciplineID": parseInt($("#SelectDiscipline").val()),
                "studyGroupID": parseInt($("#SelectGroup").val())
            },
            successCallback: function () {

            },
            failCallback: function () {
                EventInspector.error('Не удалось напечатать ведомость!');
            }
        });
    });


    $('body').on('click', '#DownloadXML', function () {
        $.fileDownload(g_URLdir + 'handler/XMLCreator/GenerateXMLFile', {
            httpMethod: "POST",
            data: {
                "disciplineID": parseInt($("#SelectDiscipline").val()),
                "studyGroupID": parseInt($("#SelectGroup").val())
            },
            successCallback: function () {

            },
            failCallback: function () {

            }
        });
    });

    // Блокирование дисциплины

    // Печать ведомости и блокирование дисциплины


});
